var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var NativeView_1;
import '@nativescript/macos-node-api';
import { Event } from '../../dom/dom-utils.js';
export class MouseDownEvent extends Event {
    nsEvent;
    constructor(nsEvent) {
        super('mouseDown');
        this.nsEvent = nsEvent;
    }
}
export class MouseUpEvent extends Event {
    nsEvent;
    constructor(nsEvent) {
        super('mouseUp');
        this.nsEvent = nsEvent;
    }
}
export class MouseMoveEvent extends Event {
    nsEvent;
    constructor(nsEvent) {
        super('mouseMove');
        this.nsEvent = nsEvent;
    }
}
export class MouseEnterEvent extends Event {
    nsEvent;
    constructor(nsEvent) {
        super('mouseEnter');
        this.nsEvent = nsEvent;
    }
}
export class MouseLeaveEvent extends Event {
    nsEvent;
    constructor(nsEvent) {
        super('mouseLeave');
        this.nsEvent = nsEvent;
    }
}
export class MouseDraggedEvent extends Event {
    nsEvent;
    constructor(nsEvent) {
        super('mouseDragged');
        this.nsEvent = nsEvent;
    }
}
let NativeView = class NativeView extends NSView {
    static { NativeView_1 = this; }
    static ObjCExposedMethods = {
        isFlipped: { returns: interop.types.bool, params: [] },
    };
    _owner = null;
    static initWithOwner(owner) {
        const view = NativeView_1.new();
        view._owner = owner;
        return view;
    }
    //@ts-ignore
    isFlipped() {
        return true;
    }
    mouseDown(event) {
        this._owner?.deref()?.dispatchEvent(new MouseDownEvent(event));
    }
    otherMouseDown(event) {
        this._owner?.deref()?.dispatchEvent(new MouseDownEvent(event));
    }
    rightMouseDown(event) {
        this._owner?.deref()?.dispatchEvent(new MouseDownEvent(event));
    }
    rightMouseUp(event) {
        this._owner?.deref()?.dispatchEvent(new MouseUpEvent(event));
    }
    rightMouseDragged(event) {
        this._owner?.deref()?.dispatchEvent(new MouseDraggedEvent(event));
    }
    otherMouseDragged(event) {
        this._owner?.deref()?.dispatchEvent(new MouseDraggedEvent(event));
    }
    otherMouseUp(event) {
        this._owner?.deref()?.dispatchEvent(new MouseUpEvent(event));
    }
    mouseUp(event) {
        this._owner?.deref()?.dispatchEvent(new MouseUpEvent(event));
    }
    mouseMoved(event) {
        this._owner?.deref()?.dispatchEvent(new MouseMoveEvent(event));
    }
    mouseDragged(event) {
        this._owner?.deref()?.dispatchEvent(new MouseDraggedEvent(event));
    }
    mouseEntered(event) {
        this._owner?.deref()?.dispatchEvent(new MouseEnterEvent(event));
    }
    mouseExited(event) {
        this._owner?.deref()?.dispatchEvent(new MouseLeaveEvent(event));
    }
};
NativeView = NativeView_1 = __decorate([
    NativeClass
], NativeView);
export { NativeView };
//# sourceMappingURL=native-view.js.map